# Templates

## Get templates by organization [#get-templates-by-organization]

### Code samples [#code-samples]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/organizations/{organization}/templates`

Returns a list of templates for the specified organization.
By default, only non-deprecated templates are returned.
To include deprecated templates, specify `deprecated:true` in the search query.

### Parameters [#parameters]

| Name           | In   | Type         | Required | Description     |
| -------------- | ---- | ------------ | -------- | --------------- |
| `organization` | path | string(uuid) | true     | Organization ID |

### Example responses [#example-responses]

> 200 Response

```json
[
  {
    "active_user_count": 0,
    "active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
    "activity_bump_ms": 0,
    "agents_allowed": true,
    "allow_user_autostart": true,
    "allow_user_autostop": true,
    "allow_user_cancel_workspace_jobs": true,
    "autostart_requirement": {
      "days_of_week": [
        "monday"
      ]
    },
    "autostop_requirement": {
      "days_of_week": [
        "monday"
      ],
      "weeks": 0
    },
    "build_time_stats": {
      "property1": {
        "p50": 123,
        "p95": 146
      },
      "property2": {
        "p50": 123,
        "p95": 146
      }
    },
    "cors_behavior": "simple",
    "created_at": "2019-08-24T14:15:22Z",
    "created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
    "created_by_name": "string",
    "default_ttl_ms": 0,
    "deleted": true,
    "deprecated": true,
    "deprecation_message": "string",
    "description": "string",
    "disable_module_cache": true,
    "display_name": "string",
    "failure_ttl_ms": 0,
    "icon": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "max_port_share_level": "owner",
    "name": "string",
    "organization_display_name": "string",
    "organization_icon": "string",
    "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
    "organization_name": "string",
    "provisioner": "terraform",
    "require_active_version": true,
    "time_til_autostop_notify_ms": 0,
    "time_til_dormant_autodelete_ms": 0,
    "time_til_dormant_ms": 0,
    "updated_at": "2019-08-24T14:15:22Z",
    "use_classic_parameter_flow": true
  }
]
```

### Responses [#responses]

| Status | Meaning                                                 | Description | Schema                                                                           |
| ------ | ------------------------------------------------------- | ----------- | -------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.Template](/beta-docs/reference/api/schemas/#codersdktemplate) |

<h3 id="get-templates-by-organization-responseschema">Response Schema</h3>

Status Code **200**

| Name                                                                                  | Type                                                                                                            | Required | Restrictions | Description                                                                                                                                                                                                                                                                                                    |
| ------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------- | -------- | ------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `[array item]`                                                                        | array                                                                                                           | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» active_user_count`                                                                 | integer                                                                                                         | false    |              | Active user count is set to -1 when loading.                                                                                                                                                                                                                                                                   |
| `» active_version_id`                                                                 | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» activity_bump_ms`                                                                  | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» agents_allowed`                                                                    | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_autostart`                                                              | boolean                                                                                                         | false    |              | Allow user autostart and AllowUserAutostop are enterprise-only. Their values are only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                        |
| `» allow_user_autostop`                                                               | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_cancel_workspace_jobs`                                                  | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» autostart_requirement`                                                             | [codersdk.TemplateAutostartRequirement](/beta-docs/reference/api/schemas/#codersdktemplateautostartrequirement) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» days_of_week`                                                                     | array                                                                                                           | false    |              | Days of week is a list of days of the week in which autostart is allowed to happen. If no days are specified, autostart is not allowed.                                                                                                                                                                        |
| `» autostop_requirement`                                                              | [codersdk.TemplateAutostopRequirement](/beta-docs/reference/api/schemas/#codersdktemplateautostoprequirement)   | false    |              | Autostop requirement and AutostartRequirement are enterprise features. Its value is only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                     |
| `»» days_of_week`                                                                     | array                                                                                                           | false    |              | Days of week is a list of days of the week on which restarts are required. Restarts happen within the user's quiet hours (in their configured timezone). If no days are specified, restarts are not required. Weekdays cannot be specified twice.                                                              |
| Restarts will only happen on weekdays in this list on weeks which line up with Weeks. |                                                                                                                 |          |              |                                                                                                                                                                                                                                                                                                                |
| `»» weeks`                                                                            | integer                                                                                                         | false    |              | Weeks is the number of weeks between required restarts. Weeks are synced across all workspaces (and Coder deployments) using modulo math on a hardcoded epoch week of January 2nd, 2023 (the first Monday of 2023). Values of 0 or 1 indicate weekly restarts. Values of 2 indicate fortnightly restarts, etc. |
| `» build_time_stats`                                                                  | [codersdk.TemplateBuildTimeStats](/beta-docs/reference/api/schemas/#codersdktemplatebuildtimestats)             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» [any property]`                                                                   | [codersdk.TransitionStats](/beta-docs/reference/api/schemas/#codersdktransitionstats)                           | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p50`                                                                             | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p95`                                                                             | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» cors_behavior`                                                                     | [codersdk.CORSBehavior](/beta-docs/reference/api/schemas/#codersdkcorsbehavior)                                 | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_at`                                                                        | string(date-time)                                                                                               | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_id`                                                                     | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_name`                                                                   | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» default_ttl_ms`                                                                    | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deleted`                                                                           | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecated`                                                                        | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecation_message`                                                               | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» description`                                                                       | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» disable_module_cache`                                                              | boolean                                                                                                         | false    |              | Disable module cache disables the use of cached Terraform modules during provisioning.                                                                                                                                                                                                                         |
| `» display_name`                                                                      | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» failure_ttl_ms`                                                                    | integer                                                                                                         | false    |              | Failure ttl ms TimeTilDormantMillis, and TimeTilDormantAutoDeleteMillis are enterprise-only. Their values are used if your license is entitled to use the advanced template scheduling feature.                                                                                                                |
| `» icon`                                                                              | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» id`                                                                                | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» max_port_share_level`                                                              | [codersdk.WorkspaceAgentPortShareLevel](/beta-docs/reference/api/schemas/#codersdkworkspaceagentportsharelevel) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» name`                                                                              | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_display_name`                                                         | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_icon`                                                                 | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_id`                                                                   | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_name`                                                                 | string(url)                                                                                                     | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» provisioner`                                                                       | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» require_active_version`                                                            | boolean                                                                                                         | false    |              | Require active version mandates that workspaces are built with the active template version.                                                                                                                                                                                                                    |
| `» time_til_autostop_notify_ms`                                                       | integer                                                                                                         | false    |              | Time til autostop notify ms is the duration before the workspace's autostop deadline at which a reminder notification is sent. 0 disables the notification.                                                                                                                                                    |
| `» time_til_dormant_autodelete_ms`                                                    | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» time_til_dormant_ms`                                                               | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» updated_at`                                                                        | string(date-time)                                                                                               | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» use_classic_parameter_flow`                                                        | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |

#### Enumerated Values [#enumerated-values]

| Property               | Value(s)                                           |
| ---------------------- | -------------------------------------------------- |
| `cors_behavior`        | `passthru`, `simple`                               |
| `max_port_share_level` | `authenticated`, `organization`, `owner`, `public` |
| `provisioner`          | `terraform`                                        |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Create template by organization [#create-template-by-organization]

### Code samples [#code-samples-1]

```sh
# Example request using curl
curl -X POST http://coder-server:8080/api/v2/organizations/{organization}/templates \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`POST /api/v2/organizations/{organization}/templates`

> Body parameter

```json
{
  "activity_bump_ms": 0,
  "agents_allowed": true,
  "allow_user_autostart": true,
  "allow_user_autostop": true,
  "allow_user_cancel_workspace_jobs": true,
  "autostart_requirement": {
    "days_of_week": [
      "monday"
    ]
  },
  "autostop_requirement": {
    "days_of_week": [
      "monday"
    ],
    "weeks": 0
  },
  "cors_behavior": "simple",
  "default_ttl_ms": 0,
  "delete_ttl_ms": 0,
  "description": "string",
  "disable_everyone_group_access": true,
  "display_name": "string",
  "dormant_ttl_ms": 0,
  "failure_ttl_ms": 0,
  "icon": "string",
  "max_port_share_level": "owner",
  "name": "string",
  "require_active_version": true,
  "template_use_classic_parameter_flow": true,
  "template_version_id": "0ba39c92-1f1b-4c32-aa3e-9925d7713eb1",
  "time_til_autostop_notify_ms": 0
}
```

### Parameters [#parameters-1]

| Name           | In   | Type                                                                                              | Required | Description     |
| -------------- | ---- | ------------------------------------------------------------------------------------------------- | -------- | --------------- |
| `organization` | path | string                                                                                            | true     | Organization ID |
| `body`         | body | [codersdk.CreateTemplateRequest](/beta-docs/reference/api/schemas/#codersdkcreatetemplaterequest) | true     | Request body    |

### Example responses [#example-responses-1]

> 200 Response

```json
{
  "active_user_count": 0,
  "active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
  "activity_bump_ms": 0,
  "agents_allowed": true,
  "allow_user_autostart": true,
  "allow_user_autostop": true,
  "allow_user_cancel_workspace_jobs": true,
  "autostart_requirement": {
    "days_of_week": [
      "monday"
    ]
  },
  "autostop_requirement": {
    "days_of_week": [
      "monday"
    ],
    "weeks": 0
  },
  "build_time_stats": {
    "property1": {
      "p50": 123,
      "p95": 146
    },
    "property2": {
      "p50": 123,
      "p95": 146
    }
  },
  "cors_behavior": "simple",
  "created_at": "2019-08-24T14:15:22Z",
  "created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
  "created_by_name": "string",
  "default_ttl_ms": 0,
  "deleted": true,
  "deprecated": true,
  "deprecation_message": "string",
  "description": "string",
  "disable_module_cache": true,
  "display_name": "string",
  "failure_ttl_ms": 0,
  "icon": "string",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "max_port_share_level": "owner",
  "name": "string",
  "organization_display_name": "string",
  "organization_icon": "string",
  "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
  "organization_name": "string",
  "provisioner": "terraform",
  "require_active_version": true,
  "time_til_autostop_notify_ms": 0,
  "time_til_dormant_autodelete_ms": 0,
  "time_til_dormant_ms": 0,
  "updated_at": "2019-08-24T14:15:22Z",
  "use_classic_parameter_flow": true
}
```

### Responses [#responses-1]

| Status | Meaning                                                 | Description | Schema                                                                  |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/beta-docs/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get template examples by organization [#get-template-examples-by-organization]

### Code samples [#code-samples-2]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/examples \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/organizations/{organization}/templates/examples`

### Parameters [#parameters-2]

| Name           | In   | Type         | Required | Description     |
| -------------- | ---- | ------------ | -------- | --------------- |
| `organization` | path | string(uuid) | true     | Organization ID |

### Example responses [#example-responses-2]

> 200 Response

```json
[
  {
    "description": "string",
    "icon": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "markdown": "string",
    "name": "string",
    "tags": [
      "string"
    ],
    "url": "string"
  }
]
```

### Responses [#responses-2]

| Status | Meaning                                                 | Description | Schema                                                                                         |
| ------ | ------------------------------------------------------- | ----------- | ---------------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.TemplateExample](/beta-docs/reference/api/schemas/#codersdktemplateexample) |

<h3 id="get-template-examples-by-organization-responseschema">Response Schema</h3>

Status Code **200**

| Name            | Type         | Required | Restrictions | Description |
| --------------- | ------------ | -------- | ------------ | ----------- |
| `[array item]`  | array        | false    |              |             |
| `» description` | string       | false    |              |             |
| `» icon`        | string       | false    |              |             |
| `» id`          | string(uuid) | false    |              |             |
| `» markdown`    | string       | false    |              |             |
| `» name`        | string       | false    |              |             |
| `» tags`        | array        | false    |              |             |
| `» url`         | string       | false    |              |             |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get templates by organization and template name [#get-templates-by-organization-and-template-name]

### Code samples [#code-samples-3]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/{templatename} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/organizations/{organization}/templates/{templatename}`

### Parameters [#parameters-3]

| Name           | In   | Type         | Required | Description     |
| -------------- | ---- | ------------ | -------- | --------------- |
| `organization` | path | string(uuid) | true     | Organization ID |
| `templatename` | path | string       | true     | Template name   |

### Example responses [#example-responses-3]

> 200 Response

```json
{
  "active_user_count": 0,
  "active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
  "activity_bump_ms": 0,
  "agents_allowed": true,
  "allow_user_autostart": true,
  "allow_user_autostop": true,
  "allow_user_cancel_workspace_jobs": true,
  "autostart_requirement": {
    "days_of_week": [
      "monday"
    ]
  },
  "autostop_requirement": {
    "days_of_week": [
      "monday"
    ],
    "weeks": 0
  },
  "build_time_stats": {
    "property1": {
      "p50": 123,
      "p95": 146
    },
    "property2": {
      "p50": 123,
      "p95": 146
    }
  },
  "cors_behavior": "simple",
  "created_at": "2019-08-24T14:15:22Z",
  "created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
  "created_by_name": "string",
  "default_ttl_ms": 0,
  "deleted": true,
  "deprecated": true,
  "deprecation_message": "string",
  "description": "string",
  "disable_module_cache": true,
  "display_name": "string",
  "failure_ttl_ms": 0,
  "icon": "string",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "max_port_share_level": "owner",
  "name": "string",
  "organization_display_name": "string",
  "organization_icon": "string",
  "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
  "organization_name": "string",
  "provisioner": "terraform",
  "require_active_version": true,
  "time_til_autostop_notify_ms": 0,
  "time_til_dormant_autodelete_ms": 0,
  "time_til_dormant_ms": 0,
  "updated_at": "2019-08-24T14:15:22Z",
  "use_classic_parameter_flow": true
}
```

### Responses [#responses-3]

| Status | Meaning                                                 | Description | Schema                                                                  |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/beta-docs/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get template version by organization, template, and name [#get-template-version-by-organization-template-and-name]

### Code samples [#code-samples-4]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/{templatename}/versions/{templateversionname} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/organizations/{organization}/templates/{templatename}/versions/{templateversionname}`

### Parameters [#parameters-4]

| Name                  | In   | Type         | Required | Description           |
| --------------------- | ---- | ------------ | -------- | --------------------- |
| `organization`        | path | string(uuid) | true     | Organization ID       |
| `templatename`        | path | string       | true     | Template name         |
| `templateversionname` | path | string       | true     | Template version name |

### Example responses [#example-responses-4]

> 200 Response

```json
{
  "archived": true,
  "created_at": "2019-08-24T14:15:22Z",
  "created_by": {
    "avatar_url": "http://example.com",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "name": "string",
    "username": "string"
  },
  "has_external_agent": true,
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "job": {
    "available_workers": [
      "497f6eca-6276-4993-bfeb-53cbbbba6f08"
    ],
    "canceled_at": "2019-08-24T14:15:22Z",
    "completed_at": "2019-08-24T14:15:22Z",
    "created_at": "2019-08-24T14:15:22Z",
    "error": "string",
    "error_code": "REQUIRED_TEMPLATE_VARIABLES",
    "file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "initiator_id": "06588898-9a84-4b35-ba8f-f9cbd64946f3",
    "input": {
      "error": "string",
      "template_version_id": "0ba39c92-1f1b-4c32-aa3e-9925d7713eb1",
      "workspace_build_id": "badaf2eb-96c5-4050-9f1d-db2d39ca5478"
    },
    "logs_overflowed": true,
    "metadata": {
      "template_display_name": "string",
      "template_icon": "string",
      "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
      "template_name": "string",
      "template_version_name": "string",
      "workspace_build_transition": "start",
      "workspace_id": "0967198e-ec7b-4c6b-b4d3-f71244cadbe9",
      "workspace_name": "string"
    },
    "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
    "queue_position": 0,
    "queue_size": 0,
    "started_at": "2019-08-24T14:15:22Z",
    "status": "pending",
    "tags": {
      "property1": "string",
      "property2": "string"
    },
    "type": "template_version_import",
    "worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b",
    "worker_name": "string"
  },
  "matched_provisioners": {
    "available": 0,
    "count": 0,
    "most_recently_seen": "2019-08-24T14:15:22Z"
  },
  "message": "string",
  "name": "string",
  "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
  "readme": "string",
  "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
  "updated_at": "2019-08-24T14:15:22Z",
  "warnings": [
    "UNSUPPORTED_WORKSPACES"
  ]
}
```

### Responses [#responses-4]

| Status | Meaning                                                 | Description | Schema                                                                                |
| ------ | ------------------------------------------------------- | ----------- | ------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.TemplateVersion](/beta-docs/reference/api/schemas/#codersdktemplateversion) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get previous template version by organization, template, and name [#get-previous-template-version-by-organization-template-and-name]

### Code samples [#code-samples-5]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/{templatename}/versions/{templateversionname}/previous \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/organizations/{organization}/templates/{templatename}/versions/{templateversionname}/previous`

### Parameters [#parameters-5]

| Name                  | In   | Type         | Required | Description           |
| --------------------- | ---- | ------------ | -------- | --------------------- |
| `organization`        | path | string(uuid) | true     | Organization ID       |
| `templatename`        | path | string       | true     | Template name         |
| `templateversionname` | path | string       | true     | Template version name |

### Example responses [#example-responses-5]

> 200 Response

```json
{
  "archived": true,
  "created_at": "2019-08-24T14:15:22Z",
  "created_by": {
    "avatar_url": "http://example.com",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "name": "string",
    "username": "string"
  },
  "has_external_agent": true,
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "job": {
    "available_workers": [
      "497f6eca-6276-4993-bfeb-53cbbbba6f08"
    ],
    "canceled_at": "2019-08-24T14:15:22Z",
    "completed_at": "2019-08-24T14:15:22Z",
    "created_at": "2019-08-24T14:15:22Z",
    "error": "string",
    "error_code": "REQUIRED_TEMPLATE_VARIABLES",
    "file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "initiator_id": "06588898-9a84-4b35-ba8f-f9cbd64946f3",
    "input": {
      "error": "string",
      "template_version_id": "0ba39c92-1f1b-4c32-aa3e-9925d7713eb1",
      "workspace_build_id": "badaf2eb-96c5-4050-9f1d-db2d39ca5478"
    },
    "logs_overflowed": true,
    "metadata": {
      "template_display_name": "string",
      "template_icon": "string",
      "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
      "template_name": "string",
      "template_version_name": "string",
      "workspace_build_transition": "start",
      "workspace_id": "0967198e-ec7b-4c6b-b4d3-f71244cadbe9",
      "workspace_name": "string"
    },
    "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
    "queue_position": 0,
    "queue_size": 0,
    "started_at": "2019-08-24T14:15:22Z",
    "status": "pending",
    "tags": {
      "property1": "string",
      "property2": "string"
    },
    "type": "template_version_import",
    "worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b",
    "worker_name": "string"
  },
  "matched_provisioners": {
    "available": 0,
    "count": 0,
    "most_recently_seen": "2019-08-24T14:15:22Z"
  },
  "message": "string",
  "name": "string",
  "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
  "readme": "string",
  "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
  "updated_at": "2019-08-24T14:15:22Z",
  "warnings": [
    "UNSUPPORTED_WORKSPACES"
  ]
}
```

### Responses [#responses-5]

| Status | Meaning                                                         | Description | Schema                                                                                |
| ------ | --------------------------------------------------------------- | ----------- | ------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1)         | OK          | [codersdk.TemplateVersion](/beta-docs/reference/api/schemas/#codersdktemplateversion) |
| 204    | [No Content](https://tools.ietf.org/html/rfc7231#section-6.3.5) | No Content  |                                                                                       |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Create template version by organization [#create-template-version-by-organization]

### Code samples [#code-samples-6]

```sh
# Example request using curl
curl -X POST http://coder-server:8080/api/v2/organizations/{organization}/templateversions \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`POST /api/v2/organizations/{organization}/templateversions`

> Body parameter

```json
{
  "example_id": "string",
  "file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
  "message": "string",
  "name": "string",
  "provisioner": "terraform",
  "storage_method": "file",
  "tags": {
    "property1": "string",
    "property2": "string"
  },
  "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
  "user_variable_values": [
    {
      "name": "string",
      "value": "string"
    }
  ]
}
```

### Parameters [#parameters-6]

| Name           | In   | Type                                                                                                            | Required | Description                     |
| -------------- | ---- | --------------------------------------------------------------------------------------------------------------- | -------- | ------------------------------- |
| `organization` | path | string(uuid)                                                                                                    | true     | Organization ID                 |
| `body`         | body | [codersdk.CreateTemplateVersionRequest](/beta-docs/reference/api/schemas/#codersdkcreatetemplateversionrequest) | true     | Create template version request |

### Example responses [#example-responses-6]

> 201 Response

```json
{
  "archived": true,
  "created_at": "2019-08-24T14:15:22Z",
  "created_by": {
    "avatar_url": "http://example.com",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "name": "string",
    "username": "string"
  },
  "has_external_agent": true,
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "job": {
    "available_workers": [
      "497f6eca-6276-4993-bfeb-53cbbbba6f08"
    ],
    "canceled_at": "2019-08-24T14:15:22Z",
    "completed_at": "2019-08-24T14:15:22Z",
    "created_at": "2019-08-24T14:15:22Z",
    "error": "string",
    "error_code": "REQUIRED_TEMPLATE_VARIABLES",
    "file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "initiator_id": "06588898-9a84-4b35-ba8f-f9cbd64946f3",
    "input": {
      "error": "string",
      "template_version_id": "0ba39c92-1f1b-4c32-aa3e-9925d7713eb1",
      "workspace_build_id": "badaf2eb-96c5-4050-9f1d-db2d39ca5478"
    },
    "logs_overflowed": true,
    "metadata": {
      "template_display_name": "string",
      "template_icon": "string",
      "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
      "template_name": "string",
      "template_version_name": "string",
      "workspace_build_transition": "start",
      "workspace_id": "0967198e-ec7b-4c6b-b4d3-f71244cadbe9",
      "workspace_name": "string"
    },
    "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
    "queue_position": 0,
    "queue_size": 0,
    "started_at": "2019-08-24T14:15:22Z",
    "status": "pending",
    "tags": {
      "property1": "string",
      "property2": "string"
    },
    "type": "template_version_import",
    "worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b",
    "worker_name": "string"
  },
  "matched_provisioners": {
    "available": 0,
    "count": 0,
    "most_recently_seen": "2019-08-24T14:15:22Z"
  },
  "message": "string",
  "name": "string",
  "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
  "readme": "string",
  "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
  "updated_at": "2019-08-24T14:15:22Z",
  "warnings": [
    "UNSUPPORTED_WORKSPACES"
  ]
}
```

### Responses [#responses-6]

| Status | Meaning                                                      | Description | Schema                                                                                |
| ------ | ------------------------------------------------------------ | ----------- | ------------------------------------------------------------------------------------- |
| 201    | [Created](https://tools.ietf.org/html/rfc7231#section-6.3.2) | Created     | [codersdk.TemplateVersion](/beta-docs/reference/api/schemas/#codersdktemplateversion) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get all templates [#get-all-templates]

### Code samples [#code-samples-7]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/templates`

Returns a list of templates.
By default, only non-deprecated templates are returned.
To include deprecated templates, specify `deprecated:true` in the search query.

### Example responses [#example-responses-7]

> 200 Response

```json
[
  {
    "active_user_count": 0,
    "active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
    "activity_bump_ms": 0,
    "agents_allowed": true,
    "allow_user_autostart": true,
    "allow_user_autostop": true,
    "allow_user_cancel_workspace_jobs": true,
    "autostart_requirement": {
      "days_of_week": [
        "monday"
      ]
    },
    "autostop_requirement": {
      "days_of_week": [
        "monday"
      ],
      "weeks": 0
    },
    "build_time_stats": {
      "property1": {
        "p50": 123,
        "p95": 146
      },
      "property2": {
        "p50": 123,
        "p95": 146
      }
    },
    "cors_behavior": "simple",
    "created_at": "2019-08-24T14:15:22Z",
    "created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
    "created_by_name": "string",
    "default_ttl_ms": 0,
    "deleted": true,
    "deprecated": true,
    "deprecation_message": "string",
    "description": "string",
    "disable_module_cache": true,
    "display_name": "string",
    "failure_ttl_ms": 0,
    "icon": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "max_port_share_level": "owner",
    "name": "string",
    "organization_display_name": "string",
    "organization_icon": "string",
    "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
    "organization_name": "string",
    "provisioner": "terraform",
    "require_active_version": true,
    "time_til_autostop_notify_ms": 0,
    "time_til_dormant_autodelete_ms": 0,
    "time_til_dormant_ms": 0,
    "updated_at": "2019-08-24T14:15:22Z",
    "use_classic_parameter_flow": true
  }
]
```

### Responses [#responses-7]

| Status | Meaning                                                 | Description | Schema                                                                           |
| ------ | ------------------------------------------------------- | ----------- | -------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.Template](/beta-docs/reference/api/schemas/#codersdktemplate) |

<h3 id="get-all-templates-responseschema">Response Schema</h3>

Status Code **200**

| Name                                                                                  | Type                                                                                                            | Required | Restrictions | Description                                                                                                                                                                                                                                                                                                    |
| ------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------- | -------- | ------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `[array item]`                                                                        | array                                                                                                           | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» active_user_count`                                                                 | integer                                                                                                         | false    |              | Active user count is set to -1 when loading.                                                                                                                                                                                                                                                                   |
| `» active_version_id`                                                                 | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» activity_bump_ms`                                                                  | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» agents_allowed`                                                                    | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_autostart`                                                              | boolean                                                                                                         | false    |              | Allow user autostart and AllowUserAutostop are enterprise-only. Their values are only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                        |
| `» allow_user_autostop`                                                               | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_cancel_workspace_jobs`                                                  | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» autostart_requirement`                                                             | [codersdk.TemplateAutostartRequirement](/beta-docs/reference/api/schemas/#codersdktemplateautostartrequirement) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» days_of_week`                                                                     | array                                                                                                           | false    |              | Days of week is a list of days of the week in which autostart is allowed to happen. If no days are specified, autostart is not allowed.                                                                                                                                                                        |
| `» autostop_requirement`                                                              | [codersdk.TemplateAutostopRequirement](/beta-docs/reference/api/schemas/#codersdktemplateautostoprequirement)   | false    |              | Autostop requirement and AutostartRequirement are enterprise features. Its value is only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                     |
| `»» days_of_week`                                                                     | array                                                                                                           | false    |              | Days of week is a list of days of the week on which restarts are required. Restarts happen within the user's quiet hours (in their configured timezone). If no days are specified, restarts are not required. Weekdays cannot be specified twice.                                                              |
| Restarts will only happen on weekdays in this list on weeks which line up with Weeks. |                                                                                                                 |          |              |                                                                                                                                                                                                                                                                                                                |
| `»» weeks`                                                                            | integer                                                                                                         | false    |              | Weeks is the number of weeks between required restarts. Weeks are synced across all workspaces (and Coder deployments) using modulo math on a hardcoded epoch week of January 2nd, 2023 (the first Monday of 2023). Values of 0 or 1 indicate weekly restarts. Values of 2 indicate fortnightly restarts, etc. |
| `» build_time_stats`                                                                  | [codersdk.TemplateBuildTimeStats](/beta-docs/reference/api/schemas/#codersdktemplatebuildtimestats)             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» [any property]`                                                                   | [codersdk.TransitionStats](/beta-docs/reference/api/schemas/#codersdktransitionstats)                           | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p50`                                                                             | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p95`                                                                             | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» cors_behavior`                                                                     | [codersdk.CORSBehavior](/beta-docs/reference/api/schemas/#codersdkcorsbehavior)                                 | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_at`                                                                        | string(date-time)                                                                                               | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_id`                                                                     | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_name`                                                                   | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» default_ttl_ms`                                                                    | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deleted`                                                                           | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecated`                                                                        | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecation_message`                                                               | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» description`                                                                       | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» disable_module_cache`                                                              | boolean                                                                                                         | false    |              | Disable module cache disables the use of cached Terraform modules during provisioning.                                                                                                                                                                                                                         |
| `» display_name`                                                                      | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» failure_ttl_ms`                                                                    | integer                                                                                                         | false    |              | Failure ttl ms TimeTilDormantMillis, and TimeTilDormantAutoDeleteMillis are enterprise-only. Their values are used if your license is entitled to use the advanced template scheduling feature.                                                                                                                |
| `» icon`                                                                              | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» id`                                                                                | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» max_port_share_level`                                                              | [codersdk.WorkspaceAgentPortShareLevel](/beta-docs/reference/api/schemas/#codersdkworkspaceagentportsharelevel) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» name`                                                                              | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_display_name`                                                         | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_icon`                                                                 | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_id`                                                                   | string(uuid)                                                                                                    | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_name`                                                                 | string(url)                                                                                                     | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» provisioner`                                                                       | string                                                                                                          | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» require_active_version`                                                            | boolean                                                                                                         | false    |              | Require active version mandates that workspaces are built with the active template version.                                                                                                                                                                                                                    |
| `» time_til_autostop_notify_ms`                                                       | integer                                                                                                         | false    |              | Time til autostop notify ms is the duration before the workspace's autostop deadline at which a reminder notification is sent. 0 disables the notification.                                                                                                                                                    |
| `» time_til_dormant_autodelete_ms`                                                    | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» time_til_dormant_ms`                                                               | integer                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» updated_at`                                                                        | string(date-time)                                                                                               | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» use_classic_parameter_flow`                                                        | boolean                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |

#### Enumerated Values [#enumerated-values-1]

| Property               | Value(s)                                           |
| ---------------------- | -------------------------------------------------- |
| `cors_behavior`        | `passthru`, `simple`                               |
| `max_port_share_level` | `authenticated`, `organization`, `owner`, `public` |
| `provisioner`          | `terraform`                                        |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get template examples [#get-template-examples]

### Code samples [#code-samples-8]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/examples \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/templates/examples`

### Example responses [#example-responses-8]

> 200 Response

```json
[
  {
    "description": "string",
    "icon": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "markdown": "string",
    "name": "string",
    "tags": [
      "string"
    ],
    "url": "string"
  }
]
```

### Responses [#responses-8]

| Status | Meaning                                                 | Description | Schema                                                                                         |
| ------ | ------------------------------------------------------- | ----------- | ---------------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.TemplateExample](/beta-docs/reference/api/schemas/#codersdktemplateexample) |

<h3 id="get-template-examples-responseschema">Response Schema</h3>

Status Code **200**

| Name            | Type         | Required | Restrictions | Description |
| --------------- | ------------ | -------- | ------------ | ----------- |
| `[array item]`  | array        | false    |              |             |
| `» description` | string       | false    |              |             |
| `» icon`        | string       | false    |              |             |
| `» id`          | string(uuid) | false    |              |             |
| `» markdown`    | string       | false    |              |             |
| `» name`        | string       | false    |              |             |
| `» tags`        | array        | false    |              |             |
| `» url`         | string       | false    |              |             |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get template settings by ID [#get-template-settings-by-id]

### Code samples [#code-samples-9]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/{template} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/templates/{template}`

### Parameters [#parameters-7]

| Name       | In   | Type         | Required | Description |
| ---------- | ---- | ------------ | -------- | ----------- |
| `template` | path | string(uuid) | true     | Template ID |

### Example responses [#example-responses-9]

> 200 Response

```json
{
  "active_user_count": 0,
  "active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
  "activity_bump_ms": 0,
  "agents_allowed": true,
  "allow_user_autostart": true,
  "allow_user_autostop": true,
  "allow_user_cancel_workspace_jobs": true,
  "autostart_requirement": {
    "days_of_week": [
      "monday"
    ]
  },
  "autostop_requirement": {
    "days_of_week": [
      "monday"
    ],
    "weeks": 0
  },
  "build_time_stats": {
    "property1": {
      "p50": 123,
      "p95": 146
    },
    "property2": {
      "p50": 123,
      "p95": 146
    }
  },
  "cors_behavior": "simple",
  "created_at": "2019-08-24T14:15:22Z",
  "created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
  "created_by_name": "string",
  "default_ttl_ms": 0,
  "deleted": true,
  "deprecated": true,
  "deprecation_message": "string",
  "description": "string",
  "disable_module_cache": true,
  "display_name": "string",
  "failure_ttl_ms": 0,
  "icon": "string",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "max_port_share_level": "owner",
  "name": "string",
  "organization_display_name": "string",
  "organization_icon": "string",
  "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
  "organization_name": "string",
  "provisioner": "terraform",
  "require_active_version": true,
  "time_til_autostop_notify_ms": 0,
  "time_til_dormant_autodelete_ms": 0,
  "time_til_dormant_ms": 0,
  "updated_at": "2019-08-24T14:15:22Z",
  "use_classic_parameter_flow": true
}
```

### Responses [#responses-9]

| Status | Meaning                                                 | Description | Schema                                                                  |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/beta-docs/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Delete template by ID [#delete-template-by-id]

### Code samples [#code-samples-10]

```sh
# Example request using curl
curl -X DELETE http://coder-server:8080/api/v2/templates/{template} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`DELETE /api/v2/templates/{template}`

### Parameters [#parameters-8]

| Name       | In   | Type         | Required | Description |
| ---------- | ---- | ------------ | -------- | ----------- |
| `template` | path | string(uuid) | true     | Template ID |

### Example responses [#example-responses-10]

> 200 Response

```json
{
  "detail": "string",
  "message": "string",
  "validations": [
    {
      "detail": "string",
      "field": "string"
    }
  ]
}
```

### Responses [#responses-10]

| Status | Meaning                                                 | Description | Schema                                                                  |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Response](/beta-docs/reference/api/schemas/#codersdkresponse) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Update template settings by ID [#update-template-settings-by-id]

### Code samples [#code-samples-11]

```sh
# Example request using curl
curl -X PATCH http://coder-server:8080/api/v2/templates/{template} \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`PATCH /api/v2/templates/{template}`

> Body parameter

```json
{
  "activity_bump_ms": 0,
  "agents_allowed": true,
  "allow_user_autostart": true,
  "allow_user_autostop": true,
  "allow_user_cancel_workspace_jobs": true,
  "autostart_requirement": {
    "days_of_week": [
      "monday"
    ]
  },
  "autostop_requirement": {
    "days_of_week": [
      "monday"
    ],
    "weeks": 0
  },
  "cors_behavior": "simple",
  "default_ttl_ms": 0,
  "deprecation_message": "string",
  "description": "string",
  "disable_everyone_group_access": true,
  "disable_module_cache": true,
  "display_name": "string",
  "failure_ttl_ms": 0,
  "icon": "string",
  "max_port_share_level": "owner",
  "name": "string",
  "require_active_version": true,
  "time_til_autostop_notify_ms": 0,
  "time_til_dormant_autodelete_ms": 0,
  "time_til_dormant_ms": 0,
  "update_workspace_dormant_at": true,
  "update_workspace_last_used_at": true,
  "use_classic_parameter_flow": true
}
```

### Parameters [#parameters-9]

| Name       | In   | Type                                                                                        | Required | Description                     |
| ---------- | ---- | ------------------------------------------------------------------------------------------- | -------- | ------------------------------- |
| `template` | path | string(uuid)                                                                                | true     | Template ID                     |
| `body`     | body | [codersdk.UpdateTemplateMeta](/beta-docs/reference/api/schemas/#codersdkupdatetemplatemeta) | true     | Patch template settings request |

### Example responses [#example-responses-11]

> 200 Response

```json
{
  "active_user_count": 0,
  "active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
  "activity_bump_ms": 0,
  "agents_allowed": true,
  "allow_user_autostart": true,
  "allow_user_autostop": true,
  "allow_user_cancel_workspace_jobs": true,
  "autostart_requirement": {
    "days_of_week": [
      "monday"
    ]
  },
  "autostop_requirement": {
    "days_of_week": [
      "monday"
    ],
    "weeks": 0
  },
  "build_time_stats": {
    "property1": {
      "p50": 123,
      "p95": 146
    },
    "property2": {
      "p50": 123,
      "p95": 146
    }
  },
  "cors_behavior": "simple",
  "created_at": "2019-08-24T14:15:22Z",
  "created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
  "created_by_name": "string",
  "default_ttl_ms": 0,
  "deleted": true,
  "deprecated": true,
  "deprecation_message": "string",
  "description": "string",
  "disable_module_cache": true,
  "display_name": "string",
  "failure_ttl_ms": 0,
  "icon": "string",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "max_port_share_level": "owner",
  "name": "string",
  "organization_display_name": "string",
  "organization_icon": "string",
  "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
  "organization_name": "string",
  "provisioner": "terraform",
  "require_active_version": true,
  "time_til_autostop_notify_ms": 0,
  "time_til_dormant_autodelete_ms": 0,
  "time_til_dormant_ms": 0,
  "updated_at": "2019-08-24T14:15:22Z",
  "use_classic_parameter_flow": true
}
```

### Responses [#responses-11]

| Status | Meaning                                                 | Description | Schema                                                                  |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/beta-docs/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## Get template DAUs by ID [#get-template-daus-by-id]

### Code samples [#code-samples-12]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/{template}/daus \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/templates/{template}/daus`

### Parameters [#parameters-10]

| Name       | In   | Type         | Required | Description |
| ---------- | ---- | ------------ | -------- | ----------- |
| `template` | path | string(uuid) | true     | Template ID |

### Example responses [#example-responses-12]

> 200 Response

```json
{
  "entries": [
    {
      "amount": 0,
      "date": "string"
    }
  ],
  "tz_hour_offset": 0
}
```

### Responses [#responses-12]

| Status | Meaning                                                 | Description | Schema                                                                          |
| ------ | ------------------------------------------------------- | ----------- | ------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.DAUsResponse](/beta-docs/reference/api/schemas/#codersdkdausresponse) |

To perform this operation, you must be authenticated. [Learn more](/beta-docs/reference/api/authentication/).

## List template versions by template ID [#list-template-versions-by-template-id]

### Code samples [#code-samples-13]

```sh
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/{template}/versions \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /api/v2/templates/{template}/versions`

### Parameters [#parameters-11]

| Name               | In    | Type         | Required | Description                           |
| ------------------ | ----- | ------------ | -------- | ------------------------------------- |
| `template`         | path  | string(uuid) | true     | Template ID                           |
| `after_id`         | query | string(uuid) | false    | After ID                              |
| `include_archived` | query | boolean      | false    | Include archived versions in the list |
| `limit`            | query | integer      | false    | Page limit                            |
| `offset`           | query | integer      | false    | Page offset                           |

### Example responses [#example-responses-13]

> 200 Response

```json
[
  {
    "archived": true,
    "created_at": "2019-08-24T14:15:22Z",
    "created_by": {
      "avatar_url": "http://example.com",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "name": "string",
      "username": "string"
    },
    "has_external_agent": true,
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "job": {
      "available_workers": [
        "497f6eca-6276-4993-bfeb-53cbbbba6f08"
      ],
      "canceled_at": "2019-08-24T14:15:22Z",
      "completed_at": "2019-08-24T14:15:22Z",
      "created_at": "2019-08-24T14:15:22Z",
      "error": "string",
      "error_code": "REQUIRED_TEMPLATE_VARIABLES",
      "file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "initiator_id": "06588898-9a84-4b35-ba8f-f9cbd64946f3",
      "input": {
        "error": "string",
        "template_version_id": "0ba39c92-1f1b-4c32-aa3e-9925d7713eb1",
        "workspace_build_id": "badaf2eb-96c5-4050-9f1d-db2d39ca5478"
      },
      "logs_overflowed": true,
      "metadata": {
        "template_display_name": "string",
        "template_icon": "string",
        "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
        "template_name": "string",
        "template_version_name": "string",
        "workspace_build_transition": "start",
        "workspace_id": "0967198e-ec7b-4c6b-b4d3-f71244cadbe9",
        "workspace_name": "string"
      },
      "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
      "queue_position": 0,
      "queue_size": 0,
      "started_at": "2019-08-24T14:15:22Z",
      "status": "pending",
      "tags": {
        "property1": "string",
        "property2": "string"
      },
      "type": "template_version_import",
      "worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b",
      "worker_name": "string"
    },
    "matched_provisioners": {
      "available": 0,
      "count": 0,
      "most_recently_seen": "2019-08-24T14:15:22Z"
    },
    "message": "string",
    "name": "string",
    "organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
    "readme": "string",
    "template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
    "updated_at": "2019-08-24T14:15:22Z",
    "warnings": [
      "UNSUPPORTED_WORKSPACES"
    ]
  }
]
```

### Responses [#responses-13]

| Status | Meaning                                                 | Description | Schema                                                                                         |
| ------ | ------------------------------------------------------- | ----------- | ---------------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.TemplateVersion](/beta-docs/reference/api/schemas/#codersdktemplateversion) |

<h3 id="list-template-versions-by-template-id-responseschema">Response Schema</h3>

Status Code **200**

| Name                             | Type                                                                                                | Required | Restrictions | Description                                                                                                                                                         |
| -------------------------------- | --------------------------------------------------------------------------------------------------- | -------- | ------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `[array item]`                   | array                                                                                               | false    |              |                                                                                                                                                                     |
| `» archived`                     | boolean                                                                                             | false    |              |                                                                                                                                                                     |
| `» created_at`                   | string(date-time)                                                                                   | false    |              |                                                                                                                                                                     |
| `» created_by`                   | [codersdk.MinimalUser](/beta-docs/reference/api/schemas/#codersdkminimaluser)                       | false    |              |                                                                                                                                                                     |
| `»» avatar_url`                  | string(uri)                                                                                         | false    |              |                                                                                                                                                                     |
| `»» id`                          | string(uuid)                                                                                        | true     |              |                                                                                                                                                                     |
| `»» name`                        | string                                                                                              | false    |              |                                                                                                                                                                     |
| `»» username`                    | string                                                                                              | true     |              |                                                                                                                                                                     |
| `» has_external_agent`           | boolean                                                                                             | false    |              |                                                                                                                                                                     |
| `» id`                           | string(uuid)                                                                                        | false    |              |                                                                                                                                                                     |
| `» job`                          | [codersdk.ProvisionerJob](/beta-docs/reference/api/schemas/#codersdkprovisionerjob)                 | false    |              |                                                                                                                                                                     |
| `»» available_workers`           | array                                                                                               | false    |              |                                                                                                                                                                     |
| `»» canceled_at`                 | string(date-time)                                                                                   | false    |              |                                                                                                                                                                     |
| `»» completed_at`                | string(date-time)                                                                                   | false    |              |                                                                                                                                                                     |
[...]
